routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\SingerController;
use App\Http\Controllers\SongController;
use App\Http\Controllers\AlbumController;
use App\Http\Controllers\UserController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::middleware('auth')->group(function () {
    Route::resource('category', CategoryController::class);
    Route::resource('singer', SingerController::class);
    Route::resource('song', SongController::class);
    Route::resource('album', AlbumController::class);
    Route::resource('users', UserController::class);
});


Route::get('/', function () {
    return view('home');
})->middleware(['auth'])->name('dashboard');
require __DIR__.'/auth.php';

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\CategoryModel;
use App\Http\Requests\CategoryRequest;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = CategoryModel::all();
        return view('categories.category',[
            'categories'=>$categories,
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('categories.add');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CategoryRequest $request)
    {
        $categories = CategoryModel::create([
            'name' => $request->input('name'),
            'picture' => 'categories/'.$request->file->getClientOriginalName(),
        ]);
        $categories->save();
        $request->file->move("categories/", $request->file->getClientOriginalName());

        return redirect()->route('category.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $categories = CategoryModel::find($id);
        return view('categories.edit', [
            'categories'=> $categories,
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $categories = CategoryModel::where('id', $id)
            ->update([
                'name'=>$request->input('name'),
                'picture' => 'categories/'.$request->file->getClientOriginalName(),
            ]);
            $request->file->move("categories/", $request->file->getClientOriginalName());
        return redirect()->route('category.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $categories = CategoryModel::find($id);
        $categories->delete();
        return redirect()->route('category.index');
    }
}

resources/views/categories/add.blade.php
@extends('layouts.add')
@section('add')
    <div class="card-body">
        <form action="{{ route('category.store') }}" enctype="multipart/form-data" class="row" method="post">
            @csrf
            <div class="col-12 mb-4">
                {{-- <div class="dropzone text-center">
                    <div class="dz-message">
                        <i class="ri-upload-cloud-2-line fs-2 text-dark"></i> <span class="d-block fs-6 mt-2">Drag & Drop or click to Upload</span>
                        <span class="d-block form-text mb-4">540x320 (Max: 300KB)</span> <button type="button" class="btn btn-light-primary">Upload cover image</button>
                    </div>
                </div> --}}
                <input type="file" name="file">
            </div>
            <div class="col-12 mb-4">
                <input type="text" class="form-control" placeholder="Name Category" name="name" />
            </div>
            <div class="card-footer text-center"><button  type="submit" class="btn btn-primary" style="min-width: 140px;">ADD</button> </div>
        </form>
    </div>

@endsection

resources/views/categories/category.blade.php
@extends('layouts.form')
@section('page_content')
<div class="under-hero container">
    <div class="section">
        <div class="section__head">
            <h3 class="mb-0">Music <span class="text-primary">Category</span></h3>
        </div>

        <div class="row g-4">
            @foreach ($categories as $category)
            <div class="col-xl-3 col-sm-6">
                <div class="cover cover--round cover__image">
                    <a href="" class="cover__image">
                        <img src="{{ $category->picture }}" alt="Remix" />
                        <div class="cover__image__content"><span class="cover__title mb-1 fs-6 text-truncate">{{ $category->name }}</span></div>
                    </a>
                    <a href="{{ route('category.edit', $category->id) }}">
                        <button type='submit' class='btn bg-yellow    btn-flat'  name=''>Sửa</button>
                    </a>
                    <form action="{{ route('category.destroy', $category->id) }}" method="POST" onclick="return confirm('Are you sure?')">
                        @csrf
                        @method('DELETE')
                        <button type='submit' class='btn bg-red btn-flat'>Xóa</button></a>
                    </form>
                </div>
            </div>
            @endforeach
        </div>

    </div>
</div>
@endsection

resources/views/categories/edit.blade.php
@extends('layouts.form')
@section('page_content')

    <div class="card-body">
        <form action="{{ route('category.update', $categories->id) }}" enctype="multipart/form-data" class="row" method="post">
            @csrf
            @method('PUT')

            <div class="col-12 mb-4">
                <input type="file" name="file" value="{{ $categories->path }}">
            </div>
            <div class="col-12 mb-4">
                <input type="text" class="form-control" placeholder="Name Category" name="name" value="{{ $categories->name }}"/>
            </div>
            <div class="card-footer text-center"><button  type="submit" class="btn btn-primary" style="min-width: 140px;">Edit</button> </div>
        </form>
    </div>

@endsection